<template>
    <div class="execution">
        <basic-container>
            <avue-crud ref="crud"
                       :page.sync="page"
                       :data="tableData"
                       :permission="permissionList"
                       :table-loading="tableLoading"
                       :option="tableOption"
                       @on-load="getList"
                       @search-change="searchChange"
                       @refresh-change="refreshChange"
                       @size-change="sizeChange"
                       @current-change="currentChange"
                       @row-update="handleUpdate"
                       @row-save="handleSave"
                       @row-del="handleDel">
                <template slot="menuLeft">
                    <el-button
                            v-if="permissions.admin_tsktaskinfo_export"
                            class="filter-item"
                            plain
                            type="primary"
                            size="small"
                            icon="el-icon-download"
                            @click="exportExcel">导出
                    </el-button>
                </template>
                <template slot-scope="{type,row,size,index}" slot="menu">
                  <el-button  :size="size" :type="type" >取消任务</el-button><br>
                  <el-button  :size="size" :type="type" style="margin-top: -5px" >查看详情</el-button><br>
                  <el-button  :size="size" :type="type" style="margin-top: -5px" >领取任务员</el-button><br>
                </template>
            </avue-crud>
        </basic-container>
    </div>
</template>

<script>
    import {fetchList, getObj, addObj, putObj, delObj} from '@/api/admin/tsktaskinfo'
    import {tableOption} from '@/const/crud/admin/tsktaskinfo'
    import {mapGetters} from 'vuex'
    import {searchTimeFormatter} from "@/util/common";

    export default {
        name: 'tsktaskinfo',
        data() {
            return {
                searchForm: {},
                tableData: [],
                page: {
                    total: 0, // 总页数
                    currentPage: 1, // 当前页数
                    pageSize: 20 // 每页显示多少条
                },
                tableLoading: false,
                tableOption: tableOption
            }
        },
        computed: {
            ...mapGetters(['permissions']),
            permissionList() {
                return {
                    addBtn: this.vaildData(this.permissions.admin_tsktaskinfo_add, false),
                    delBtn: this.vaildData(this.permissions.admin_tsktaskinfo_del, false),
                    editBtn: this.vaildData(this.permissions.admin_tsktaskinfo_edit, false)
                };
            }
        },
        methods: {
            // 列表查询
            getList(page, params) {
                params = searchTimeFormatter(params,'createTime');
                this.tableLoading = true
                fetchList(Object.assign({
                    current: page.currentPage,
                    size: page.pageSize
                }, params, this.searchForm )).then(response => {
                    this.tableData = response.data.data.records
                    this.page.total = response.data.data.total
                    this.tableLoading = false
                }).catch(() => {
                    this.tableLoading=false
                })
            },
            // 删除
            handleDel: function (row, index) {
                this.$confirm('是否确认删除ID为' + row.id, '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(function () {
                    return delObj(row.id)
                }).then(data => {
                    this.$message.success('删除成功')
                    this.getList(this.page)
                })
            },
            // 更新
            handleUpdate: function (row, index, done,loading) {
                putObj(row).then(data => {
                    this.$message.success('修改成功')
                    done()
                    this.getList(this.page)
                }).catch(() => {
                    loading();
                });
            },
            // 保存
            handleSave: function (row, done,loading) {
                addObj(row).then(data => {
                    this.$message.success('添加成功')
                    done()
                    this.getList(this.page)
                }).catch(() => {
                    loading();
                });
            },
            // 每页条数改变事件
            sizeChange(pageSize){
                this.page.pageSize = pageSize
            },
            // 当前页发生改变事件
            currentChange(current){
                this.page.currentPage = current
            },
            // 查询事件
            searchChange(form, done) {
                this.searchForm = form
                this.page.currentPage = 1
                this.getList(this.page, form)
                done()
            },
            // 刷新事件
            refreshChange() {
                this.getList(this.page)
            },
            //  导出excel
            exportExcel() {
                this.downBlobFile('/admin/tsktaskinfo/export',this.searchForm, 'tsktaskinfo.xlsx')
            }
        }
    }
</script>
